--TODO: tee nist moduuleja joita voi kytt luokkien tapaan...
require 'g_level'
require 'g_sewer_aid'
g_level.reset()

fade_in(2)
--INIT TEXTURES  -- adds a texture into ObjectManager<Texture>
h = FM_NEAREST;

-- textures
lua_init_texture("sewer_tileset", "data/images/sewer/sewer_tileset.png", h, WM_REPEAT,WM_CLAMP,AM_MODULATE)
lua_init_texture("sewer_tileset2", "data/images/sewer/sewer_tileset2.png", h, WM_REPEAT,WM_CLAMP,AM_MODULATE)
lua_init_texture("sewer_objects", "data/images/sewer/sewer_objects_1.png",h,WM_REPEAT,WM_CLAMP,AM_MODULATE)
lua_init_texture("sewer_steam", "data/images/sewer/steam.png",h,WM_REPEAT,WM_CLAMP,AM_MODULATE)
lua_init_texture("sewer_unstable_floor", "data/images/sewer/frac_grnd_holder.png",h,WM_REPEAT,WM_CLAMP,AM_MODULATE)
lua_init_texture("sewer_gate", "data/images/sewer/gate.png",h,WM_REPEAT,WM_CLAMP,AM_MODULATE)
lua_init_texture("map3", "data/images/sewer/maps/map_3.png",h,WM_REPEAT,WM_CLAMP,AM_MODULATE)
lua_init_texture("sewer_fore", "data/images/sewer/sewer_fore.png",h,WM_REPEAT,WM_CLAMP,AM_MODULATE)
lua_init_texture("barrel", "data/images/sewer/broken_barrel.png",h,WM_REPEAT,WM_CLAMP,AM_MODULATE)
lua_init_texture("drop", "data/images/sewer/drop.png",h,WM_REPEAT,WM_CLAMP,AM_MODULATE)
lua_init_texture("switch", "data/images/lvl_forest/switch.png",h,WM_REPEAT,WM_CLAMP,AM_MODULATE)
lua_init_texture("fairy", "data/images/characters/keiju_32.png",h,WM_REPEAT,WM_CLAMP,AM_MODULATE)

-- Create Level
lua:create_level(1.0,1.0,1.0,1.0)   --RGBA values are given also


-- Create Layers
-- The index of the layers are auto incremented. This meaning that the first one to add is 0 and rest are in order of appearance...
lua:create_layer(0.0,0.0,BM_DEFAULT)  -- x_scroll , y_scroll, blendmode  -- 0
lua:create_layer(0.2,0.2,BM_DEFAULT) -- 1 = taustavuoret
lua:create_layer(0.4,0.4,BM_DEFAULT) -- 2 = taustamets
lua:create_layer(0.75,0.75,BM_DEFAULT) -- 3 = lhipuita
local parallax_x = 1.0
local parallax_y = 1.0

local kamerapurkka = 1.0; --kun pelaaja on kentalla 1.0 ja rakenteluvaiheessa 0.1

lua:create_layer(parallax_x,parallax_y,BM_DEFAULT) -- 4
lua:create_layer(parallax_x,parallax_y,BM_DEFAULT) -- 5
lua:create_layer(kamerapurkka , kamerapurkka ,BM_DEFAULT) -- 6 = fysiikka + pelaaja
lua:create_layer(1.0,1.0,BM_DEFAULT) -- 7 = joitain ruoho/kivijuttuja
lua:create_layer(1.3,1.3,BM_DEFAULT) -- 8 = foreground
lua:create_layer(0.0,0.0,BM_DEFAULT) -- 9 = dummy, for menus


lua:init_subtexture("switch","switch_1", 0.0, 0.0, 0.5, 1.0)
lua:init_subtexture("switch","switch_2", 0.0, 0.0, 0.5, 1.0)
lua:init_subtexture("switch","switch_3", 0.5, 0.0, 1.0, 1.0)
lua:init_subtexture("switch","switch_4", 0.5, 0.0, 1.0, 1.0)

lua:init_animation("lever_open", MODE_ONCE, DIRECTION_FORWARD)
local k = 0.075
lua:animation_add_frame("lever_open","switch_1",k)
lua:animation_add_frame("lever_open","switch_2",k)
lua:init_animation("lever_close", MODE_ONCE, DIRECTION_FORWARD)
lua:animation_add_frame("lever_close","switch_3",k)
lua:animation_add_frame("lever_close","switch_4",k)

lua:layer_color(6, 5.2, 5.2, 5.2, 1.0)
local tileSize = 256*(2/3)
local mainY = 0.0;

-- Fore Graphics
lua:create_sprite("sewer", ST_TEXTURED,"sewer_fore", 1024.0+512.0, 0.0) -- nimi, joku, tekstuurin nimi, x, y
lua:sprite_color("sewer", 0.2, 0.2, 0.2 , 1.0)
lua:sprite_shape("sewer",ST_TEXTURED, 3*tileSize*12, tileSize*3)
lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.0, 0.0, 3.0, 1.0)
g_level.upload("sewer", 8)
lua:create_sprite("sewer", ST_TEXTURED,"sewer_fore", 1024.0+512.0, 1024.0) -- nimi, joku, tekstuurin nimi, x, y
lua:sprite_color("sewer", 0.2, 0.2, 0.2 , 1.0)
lua:sprite_shape("sewer",ST_TEXTURED, 3*tileSize*12, tileSize*3)
lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.0, 1.0, 3.0, 0.0)
g_level.upload("sewer", 8)

-- Main tiles

-- Basic
lua:create_sprite("sewer", ST_TEXTURED,"sewer_tileset", tileSize*-2, mainY) -- nimi, joku, tekstuurin nimi, x, y
lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 1.0)
lua:sprite_shape("sewer",ST_TEXTURED, tileSize, tileSize*2)
lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.0, 0.5, 0.25, 1.0)
g_level.upload("sewer", 6)

-- Wall ending
lua:create_sprite("sewer", ST_TEXTURED,"sewer_tileset",0.0, mainY) -- nimi, joku, tekstuurin nimi, x, y
lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 1.0)
lua:sprite_shape("sewer",ST_TEXTURED, tileSize, tileSize*2)
lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.75, 0.0, 1.0, 0.5)
g_level.upload("sewer", 6)

-- Enterance
lua:create_sprite("sewer", ST_TEXTURED,"sewer_tileset", tileSize*3, mainY) -- nimi, joku, tekstuurin nimi, x, y
lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 1.0)
lua:sprite_shape("sewer",ST_TEXTURED, tileSize*2, tileSize*2)
lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.5, 0.5, 1.0, 1.0)
g_level.upload("sewer", 6)


-- Basic
lua:create_sprite("sewer", ST_TEXTURED,"sewer_tileset", tileSize*6, mainY) -- nimi, joku, tekstuurin nimi, x, y
lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 1.0)
lua:sprite_shape("sewer",ST_TEXTURED, tileSize, tileSize*2)
lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.0, 0.5, 0.25, 1.0)
g_level.upload("sewer", 6)


-- Gap start
lua:create_sprite("sewer", ST_TEXTURED,"sewer_tileset", tileSize*8, mainY) -- nimi, joku, tekstuurin nimi, x, y
lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 1.0)
lua:sprite_shape("sewer",ST_TEXTURED, tileSize, tileSize*2)
lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.0, 0.0, 0.25, 0.5)
g_level.upload("sewer", 6)

-- Gap
lua:create_sprite("sewer", ST_TEXTURED,"sewer_tileset", tileSize*10, mainY) -- nimi, joku, tekstuurin nimi, x, y
lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 1.0)
lua:sprite_shape("sewer",ST_TEXTURED, tileSize, tileSize*2)
lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.25, 0.0, 0.5, 0.5)
g_level.upload("sewer", 6)

-- Gap
lua:create_sprite("sewer", ST_TEXTURED,"sewer_tileset", tileSize*12, mainY) -- nimi, joku, tekstuurin nimi, x, y
lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 1.0)
lua:sprite_shape("sewer",ST_TEXTURED, tileSize, tileSize*2)
lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.25, 0.0, 0.5, 0.5)
g_level.upload("sewer", 6)

-- Gap
lua:create_sprite("sewer", ST_TEXTURED,"sewer_tileset", tileSize*14, mainY) -- nimi, joku, tekstuurin nimi, x, y
lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 1.0)
lua:sprite_shape("sewer",ST_TEXTURED, tileSize, tileSize*2)
lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.25, 0.0, 0.5, 0.5)
g_level.upload("sewer", 6)

-- Gap end
lua:create_sprite("sewer", ST_TEXTURED,"sewer_tileset", tileSize*16, mainY) -- nimi, joku, tekstuurin nimi, x, y
lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 1.0)
lua:sprite_shape("sewer",ST_TEXTURED, tileSize, tileSize*2)
lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.5, 0.0, 0.75, 0.5)
g_level.upload("sewer", 6)


-- Wall ending
lua:create_sprite("sewer", ST_TEXTURED,"sewer_tileset", tileSize*18, mainY) -- nimi, joku, tekstuurin nimi, x, y
lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 1.0)
lua:sprite_shape("sewer",ST_TEXTURED, tileSize, tileSize*2)
lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.75, 0.0, 1.0, 0.5)
g_level.upload("sewer", 6)

-- Enterance
lua:create_sprite("sewer", ST_TEXTURED,"sewer_tileset", tileSize*21, mainY) -- nimi, joku, tekstuurin nimi, x, y
lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 1.0)
lua:sprite_shape("sewer",ST_TEXTURED, tileSize*2, tileSize*2)
lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.5, 0.5, 1.0, 1.0)
g_level.upload("sewer", 6)

-- Basic
lua:create_sprite("sewer", ST_TEXTURED,"sewer_tileset", tileSize*24, mainY) -- nimi, joku, tekstuurin nimi, x, y
lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 1.0)
lua:sprite_shape("sewer",ST_TEXTURED, tileSize, tileSize*2)
lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.0, 0.5, 0.25, 1.0)
g_level.upload("sewer", 6)

-- Enterance
lua:create_sprite("sewer", ST_TEXTURED,"sewer_tileset", tileSize*27, mainY) -- nimi, joku, tekstuurin nimi, x, y
lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 1.0)
lua:sprite_shape("sewer",ST_TEXTURED, tileSize*2, tileSize*2)
lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.5, 0.5, 1.0, 1.0)
g_level.upload("sewer", 6)

-- Basic
lua:create_sprite("sewer", ST_TEXTURED,"sewer_tileset", tileSize*30, mainY) -- nimi, joku, tekstuurin nimi, x, y
lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 1.0)
lua:sprite_shape("sewer",ST_TEXTURED, tileSize, tileSize*2)
lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.0, 0.5, 0.25, 1.0)
g_level.upload("sewer", 6)

-- Basic
lua:create_sprite("sewer", ST_TEXTURED,"sewer_tileset", tileSize*32, mainY) -- nimi, joku, tekstuurin nimi, x, y
lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 1.0)
lua:sprite_shape("sewer",ST_TEXTURED, tileSize, tileSize*2)
lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.0, 0.5, 0.25, 1.0)
g_level.upload("sewer", 6)

-- Basic
lua:create_sprite("sewer", ST_TEXTURED,"sewer_tileset", tileSize*34, mainY) -- nimi, joku, tekstuurin nimi, x, y
lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 1.0)
lua:sprite_shape("sewer",ST_TEXTURED, tileSize, tileSize*2)
lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.0, 0.5, 0.25, 1.0)
g_level.upload("sewer", 6)



-- Main tiles end
-- Map
lua:create_sprite("sewer", ST_TEXTURED,"map3", 210.0, 160.0) -- nimi, joku, tekstuurin nimi, x, y
lua:sprite_color("sewer", 0.2, 0.2, 0.2 , 1.0)
lua:sprite_shape("sewer",ST_TEXTURED, tileSize/2, tileSize/2)
lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.0, 0.0, 1.0, 1.0)
g_level.upload("sewer", 6)




-- Ground (upper)
groundLenght = 4
for i=0,groundLenght,1 
do
    lua:create_sprite("sewer", ST_TEXTURED,"sewer_tileset2", i*tileSize*8+tileSize*1, mainY+tileSize*3-2) -- nimi, joku, tekstuurin nimi, x, y
    lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 1.0)
    lua:sprite_shape("sewer",ST_TEXTURED, tileSize*4, tileSize)
    lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.0, 0.25, 1.0, 0.5)
    g_level.upload("sewer", 6)
end
-- Ground end


--running water start
local waterLenght = 5;
local waterSpdY= 0.1;
local waterY = -150;
for i=1,waterLenght,1 
do
    local waterX = -1600+i*tileSize*8*1.5

    lua:create_sprite("sewer", ST_SCROLLING,"sewer_tileset2", waterX, waterY) -- nimi, joku, tekstuurin nimi, x, y
    lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 0.3)
    lua:sprite_shape("sewer",ST_SCROLLING, tileSize*1.5*4, tileSize*1*1.5)
    lua:textured_sprite_tex_coords("sewer", ST_SCROLLING, 0.0, 0.0, 1.0, 0.25) --0.75, 0.0, 1.0, 0.15
    lua:scrolling_sprite("sewer", SS_HORIZONTAL, 0.03) -- name. type of scrolling. scrolling speed
    lua:remorfable_sprite("water", "sewer", waterSpdY, true)             -- name, sprite_name, speed, repeat

    lua:add_key_frame(0.5, waterX, waterY-30, 0.0, 1.0)  -- adds a new key frame. time, x, y, rotation, scale
    lua:add_key_frame_color(1.0,1.0,1.0,0.3)  -- r,g,b,a
    lua:upload_key_frame("water")
    
    g_level.upload("water", 6)
    
    --**2**	
    lua:create_sprite("sewer", ST_SCROLLING,"sewer_tileset2", waterX, waterY-50) -- nimi, joku, tekstuurin nimi, x, y
    lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 0.2)
    lua:sprite_shape("sewer",ST_SCROLLING, tileSize*1.5*4, tileSize*1*1.5)
    lua:textured_sprite_tex_coords("sewer", ST_SCROLLING, 0.0, 0.0, 1.0, 0.25) --0.75, 0.0, 1.0, 0.15
    lua:scrolling_sprite("sewer", SS_HORIZONTAL, 0.02) -- name. type of scrolling. scrolling speed
    lua:remorfable_sprite("water", "sewer", waterSpdY/2, true)             -- name, sprite_name, speed, repeat

    lua:add_key_frame(0.5, waterX, waterY-20, 0.0, 1.0)  -- adds a new key frame. time, x, y, rotation, scale
    lua:add_key_frame_color(1.0,1.0,1.0,0.2)  -- r,g,b,a
    lua:upload_key_frame("water")
    
    g_level.upload("water", 6)
    -- **3**
    lua:create_sprite("sewer", ST_SCROLLING,"sewer_tileset2", waterX, waterY-100) -- nimi, joku, tekstuurin nimi, x, y
    lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 0.2)
    lua:sprite_shape("sewer",ST_SCROLLING, tileSize*1.5*4, tileSize*1*1.5)
    lua:textured_sprite_tex_coords("sewer", ST_SCROLLING, 0.0, 0.0, 1.0, 0.25) --0.75, 0.0, 1.0, 0.15
    lua:scrolling_sprite("sewer", SS_HORIZONTAL, 0.025) -- name. type of scrolling. scrolling speed
    lua:remorfable_sprite("water", "sewer", waterSpdY/2, true)             -- name, sprite_name, speed, repeat

    lua:add_key_frame(0.5, waterX, waterY-100, 0.0, 1.0)  -- adds a new key frame. time, x, y, rotation, scale
    lua:add_key_frame_color(1.0,1.0,1.0,0.2)  -- r,g,b,a
    lua:upload_key_frame("water")
    
    g_level.upload("water", 6)

    
end
--running water end

-- steam start
local steamGap = 100
local steamLenght=50

for j=0,2,1
do 
    for i=0,steamLenght,1 
    do
        local steamPlace = 0+steamGap*i
        local steamSpd = math.random()/20 + 0.05
        
        lua:create_sprite("steam", ST_TEXTURED,"sewer_steam", steamPlace, -256.0*1.5) 
        lua:sprite_shape("steam",ST_TEXTURED, 64.0, 64.0)
        lua:textured_sprite_tex_coords("steam", ST_TEXTURED,0.0, 0.0, 1.0, 1.0)
        lua:remorfable_sprite("st", "steam", steamSpd, true)             -- name, sprite_name, speed, repeat

        lua:add_key_frame(0.0, steamPlace, -256.0*1.5, 0.0, 1.0)  -- adds a new key frame. time, x, y, rotation, scale
        lua:add_key_frame_color(1.0,1.0,1.0,0.4)  -- r,g,b,a
        lua:upload_key_frame("st")

        lua:add_key_frame(1.0, steamPlace, 0.0, 0.0, 2.0)  -- adds a new key frame. time, x, y, rotation, scale
        lua:add_key_frame_color(1.0,1.0,1.0,0.0)  -- r,g,b,a
        lua:upload_key_frame("st")

        g_level.upload("st",6)
    end
end
-- steam end



-- Objects

    -- box1
    lua:create_sprite("sewer", ST_TEXTURED,"sewer_objects", tileSize*8, 0.0) -- nimi, joku, tekstuurin nimi, x, y
    lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 1.0)
    lua:sprite_shape("sewer",ST_TEXTURED, tileSize/4, tileSize/4)
    lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.0, 0.75, 0.25, 1.0)
    g_level.upload("sewer",6)
    
    -- box1
    lua:create_sprite("sewer", ST_TEXTURED,"sewer_objects",tileSize*8+80, -10.0) -- nimi, joku, tekstuurin nimi, x, y
    lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 1.0)
    lua:sprite_shape("sewer",ST_TEXTURED, tileSize/4, tileSize/4)
    lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.25, 0.75, 0.5, 1.0)
       g_level.upload("sewer",6)
    
    -- box2
    lua:create_sprite("sewer", ST_TEXTURED,"sewer_objects",tileSize*8+40, 40.0) -- nimi, joku, tekstuurin nimi, x, y
    lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 1.0)
    lua:sprite_shape("sewer",ST_TEXTURED, tileSize/4, tileSize/4)
    lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.25, 0.75, 0.5, 1.0)
        g_level.upload("sewer",6)
    	
    -- box1
    lua:create_sprite("sewer", ST_TEXTURED,"sewer_objects", tileSize*15.2, 0.0) -- nimi, joku, tekstuurin nimi, x, y
    lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 1.0)
    lua:sprite_shape("sewer",ST_TEXTURED, tileSize/4, tileSize/4)
    lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.0, 0.75, 0.25, 1.0)
        g_level.upload("sewer",6)
    
    -- barrel fallen
    lua:create_sprite("sewer", ST_TEXTURED,"sewer_objects", tileSize*15.5+80, -10.0) -- nimi, joku, tekstuurin nimi, x, y
    lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 1.0)
    lua:sprite_shape("sewer",ST_TEXTURED, tileSize/4, tileSize/4)
    lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.25, 0.5, 0.5, 0.75)
        g_level.upload("sewer",6)
    
    -- box2
    lua:create_sprite("sewer", ST_TEXTURED,"sewer_objects",tileSize*15.2, 40.0) -- nimi, joku, tekstuurin nimi, x, y
    lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 1.0)
    lua:sprite_shape("sewer",ST_TEXTURED, tileSize/4, tileSize/4)
    lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.25, 0.75, 0.5, 1.0)
        g_level.upload("sewer",6)

    -- switch
   -- lua:create_sprite("sewer", ST_TEXTURED,"sewer_switch",tileSize*17, mainY) -- nimi, joku, tekstuurin nimi, x, y
   -- lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 1.0)
   -- lua:sprite_shape("sewer",ST_TEXTURED, tileSize/3, tileSize/3)
    --lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.0, 0.0, 1.0, 1.0)
      --  g_level.upload("sewer",6)

   
	--unstable floor
    --lua:create_sprite("sewer", ST_TEXTURED,"sewer_unstable_floor",tileSize*10.5, mainY) -- nimi, joku, tekstuurin nimi, x, y
    --lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 1.0)
    --lua:sprite_shape("sewer",ST_TEXTURED, tileSize/2, tileSize/2 )
    --lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.0, 0.0, 1.0, 1.0)
      --  g_level.upload("sewer",6)
	
	--unstable floor
    --lua:create_sprite("sewer", ST_TEXTURED,"sewer_unstable_floor",tileSize*13, mainY-80) -- nimi, joku, tekstuurin nimi, x, y
    --lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 1.0)
    --lua:sprite_shape("sewer",ST_TEXTURED, tileSize/2, tileSize/2)
    --lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.0, 0.0, 1.0, 1.0)
     --   g_level.upload("sewer",6)

 
-- Objects end

--LEVER
local lever1 = {2870,90,g_sewer_aid.lever_map_3} --x,y,is_closed
local lever_sound = ""
local lever_width = 128.0 /2
local lever_height = 256.0 /2
lua:create_sprite("lever_open1", ST_ANIMATED,"lever_close", lever1[1],lever1[2]) 
lua:sprite_shape("lever_open1",ST_ANIMATED,lever_width, lever_height)
lua:create_sprite("lever_close1", ST_ANIMATED,"lever_open", lever1[1],lever1[2])
lua:sprite_shape("lever_close1",ST_ANIMATED,lever_width, lever_height)
--sound creation
--lua:create_sound("lever_sound_open1",lever_sound, 500.0, lever1[1],lever1[2])  --name, music_name, radius, x,y
--lua:create_sound("lever_sound_close1",lever_sound, 500.0, lever1[1],lever1[2])  --name, music_name, radius, x,y
lua:create_lever("lever1","lever_open1","lever_close1","","",lever1[3]) --name , open animated sprite, close animated sprite, open_sound, close_sound, is_closed
local lever1_id = g_level.upload("lever1",6)
--add trigger
switch_adv("data/scripts/srt_use_lever_sewer.lua",lever1[1],lever1[2],100,lever1_id) --script ,x,y, radius, id

--DOORS
if g_sewer_aid.lever_map_3 == false then
    -- gate
    lua:create_sprite("sewer", ST_TEXTURED,"sewer_gate",tileSize*24, mainY+200) -- nimi, joku, tekstuurin nimi, x, y
    lua:sprite_shape("sewer",ST_TEXTURED, tileSize/1.5, tileSize*2.5/1.5)
    lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.0, 0.0, 1.0, 1.0)
    g_level.upload("sewer",6)
    
    lua:create_shape("generic_name_vol1",PSC_RECTANGLE,20,1000.0) -- name, type, width, height
    lua:create_collider(1111,"generic_name_vol1",4103.5,0.0) --id, shape, x ,y
    
elseif g_sewer_aid.lever_map_1 == false then
    -- gate
    lua:create_sprite("sewer", ST_TEXTURED,"sewer_gate",tileSize*30, mainY+200) -- nimi, joku, tekstuurin nimi, x, y
    lua:sprite_shape("sewer",ST_TEXTURED, tileSize/1.5, tileSize*2.5/1.5)
    lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.0, 0.0, 1.0, 1.0)
    g_level.upload("sewer",6)

    lua:create_shape("generic_name_vol1",PSC_RECTANGLE,20,1000.0) -- name, type, width, height
    lua:create_collider(1111,"generic_name_vol1",5130.5,0.0) --id, shape, x ,y
end

--Nuclear Barrels
lua:create_sprite("sewer", ST_TEXTURED,"barrel", 2000.0 , 420.0) -- nimi, joku, tekstuurin nimi, x, y
lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 1.0)
lua:sprite_shape("sewer",ST_TEXTURED, 64, 64)
lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.0, 0.0, 1.0, 1.0)
g_level.upload("sewer", 6)

--Fairy
local scale = 0.15
lua:create_sprite("sewer", ST_TEXTURED,"fairy", 5640.0 , 65.0) -- nimi, joku, tekstuurin nimi, x, y
lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 1.0)
lua:sprite_shape("sewer",ST_TEXTURED, 256*scale, 512*scale)
lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.0, 0.0, 1.0, 1.0)
g_level.upload("sewer", 6)


--UNSTABLES
lua:do_file("data/scripts/inc_sewer_unstables.lua")
create_stone_unstable(1794, 52) --x,y
create_stone_unstable(2227, -26) --x,y

lua:do_file("data/scripts/inc_poison_bullet.lua")
local spd = 0.4
--first poison drop
local path_list = {}
table.insert(path_list,{1994.0,390.0,0.0}) --x,y, time
table.insert(path_list,{1994.0,-200.0,1.0}) --x,y, time
create_poison_bullet(path_list, true, spd, 6)--path_list, is_repeating,speed ,layer

--STOPPERS
--walls
stopper(LEFT,76) --far left
--second
lua:create_shape("generic_name_vol1",PSC_RECTANGLE,123/2,1000.0) -- name, type, width, height
lua:create_collider(1111,"generic_name_vol1",3095.5,0.0) --id, shape, x ,y
--far right
stopper(RIGHT,5980.0) --id, shape, x ,y

--boxes
--left
--lua:create_shape("generic_name_vol1",PSC_RECTANGLE,66.5,65.0) -- name, type, width, height
--lua:create_collider(1111,"generic_name_vol1",1403.5,-40.0) --id, shape, x ,y
--center
--lua:create_shape("generic_name_vol1",PSC_RECTANGLE,27,106.0) -- name, type, width, height
--lua:create_collider(1111,"generic_name_vol1",1403.5,-40.0) --id, shape, x ,y
--right
--lua:create_shape("generic_name_vol1",PSC_RECTANGLE,28,104.0) -- name, type, width, height
--lua:create_collider(1111,"generic_name_vol1",2592,-40.0) --id, shape, x ,y
--right  barrel
--lua:create_shape("generic_name_vol1",PSC_RECTANGLE,28,44.0) -- name, type, width, height
--lua:create_collider(1111,"generic_name_vol1",2724,-40.0) --id, shape, x ,y

--Segments start
lua:create_segment(-255.371, -37)
lua:add_segment(426.629, -38)
lua:add_segment(432.629, -44)
lua:upload_segmentstrip()
lua:create_segment(553.456, -42)
lua:add_segment(560.456, -32)
lua:add_segment(1507.46, -34)
lua:add_segment(1512.46, -40)
lua:upload_segmentstrip()
--lua:create_segment(1721.63, 53)
--lua:add_segment(1866.63, 50)
--lua:upload_segmentstrip()
--lua:create_segment(2149.63, -28)
--lua:add_segment(2291.63, -29)
--lua:upload_segmentstrip()
lua:create_segment(2571.7, -42)
lua:add_segment(2574.7, -38)
lua:add_segment(3502.7, -36)
lua:add_segment(3505.7, -46)
lua:upload_segmentstrip()

lua:create_segment(3624.69, -41.3395)
lua:add_segment(3629.69, -32.3395)
lua:add_segment(4522.69, -41.3395)
lua:add_segment(4530.69, -46.3395)
lua:upload_segmentstrip()

lua:create_segment(4653.71, -37.373)
lua:add_segment(4658.82, -25.373)
lua:add_segment(5995.46, -26.373)
lua:upload_segmentstrip()


--Segments end

--4
switch_adv("data/scripts/srt_sewer_next_level.lua",520, 90,200,604) --script, x, y, radius, id
--5
switch_adv("data/scripts/srt_sewer_next_level.lua",3584, 79,200,605) --script, x, y, radius, id
--6
switch_adv("data/scripts/srt_sewer_next_level.lua",4612, 83,200,606) --script, x, y, radius, id
--out
trigger("data/scripts/dialogs/dia_fairy_sewer.lua","data/scripts/srt_next_level.lua",40.0,500.0,5240,0.0) --out of the sewer
--secure kill
trigger("data/scripts/srt_game_over.lua","",30000,100,10820,-350) --script, width, height, x, y


--SEWER PIPE SETTINGS
g_sewer_aid.set_map_id(3)

--Player
--INIT PLAYER
lua:do_file("data/scripts/crt_player_trigger.lua",0)
lua:init_camera_binder(-256.0, 5920.0, -350.0, 510.0) -- left, right, bottom, up
lua:upload_player_to_layer(6)  --index of the layer
if g_sewer_aid.get_prev_map_id() == 4 then 
    lua:creature_translation("player", CPT_PLAYER, 400.0,150.0) -- set the player to it's right position
elseif g_sewer_aid.get_prev_map_id() == 5 then 
    lua:creature_translation("player", CPT_PLAYER, 3444.0,150.0) -- set the player to it's right position
elseif g_sewer_aid.get_prev_map_id() == 6 then  
    lua:creature_translation("player", CPT_PLAYER, 4512.0,150.0) -- set the player to it's right position
else
    lua:creature_translation("player", CPT_PLAYER, 400.0,150.0) -- set the player to it's right position
end
--Player end
g_level.set_level("data/scripts/lvl_sewer_3.lua")

raise_from_sewer_to_butler_scene = 1313
lua:set_game_state(GS_PLAY) -- sets the game state to menu. thus you are able to use the menu commands
g_level.next_level = "data/scripts/lvl_city.lua"
