--TODO: tee nist moduuleja joita voi kytt luokkien tapaan...
require 'g_level'
g_level.reset()

--INIT TEXTURES  -- adds a texture into ObjectManager<Texture>
h = FM_NEAREST;
lua_init_texture("background_forest", "data/images/taivastausta-parallax_2.png", h, WM_REPEAT,WM_CLAMP,AM_MODULATE)

--load tileset
lua_init_texture("tileset", "data/images/lvl_forest/forest_tileset.png", h, WM_REPEAT,WM_CLAMP,AM_MODULATE)
lua_init_texture("tileset2", "data/images/lvl_forest/forest_tileset2.png", h, WM_REPEAT,WM_CLAMP,AM_MODULATE)
lua_init_texture("mattaat", "data/images/lvl_forest/forest_middle.png", h, WM_REPEAT,WM_CLAMP,AM_MODULATE)
lua_init_texture("sign2", "data/images/lvl_forest/sign2.png", h, WM_REPEAT,WM_CLAMP,AM_MODULATE)

lua_init_texture("trees_1", "data/images/lvl_forest/puu_01.png", h, WM_REPEAT,WM_CLAMP,AM_MODULATE)
lua_init_texture("trees_2", "data/images/lvl_forest/puu_02.png",h,WM_REPEAT,WM_CLAMP,AM_MODULATE)
lua_init_texture("trees_3", "data/images/lvl_forest/puu_03.png",h,WM_REPEAT,WM_CLAMP,AM_MODULATE)
lua_init_texture("trees_4", "data/images/lvl_forest/puu_04.png",h,WM_REPEAT,WM_CLAMP,AM_MODULATE)
lua_init_texture("trees_5", "data/images/lvl_forest/puu_05.png",h,WM_REPEAT,WM_CLAMP,AM_MODULATE)
lua_init_texture("trees_6", "data/images/lvl_forest/puu_06.png",h,WM_REPEAT,WM_CLAMP,AM_MODULATE)
lua_init_texture("trees_7", "data/images/lvl_forest/puu_07.png",h,WM_REPEAT,WM_CLAMP,AM_MODULATE)
lua_init_texture("trees_8", "data/images/lvl_forest/puunrunko.png",h,WM_REPEAT,WM_CLAMP,AM_MODULATE)

lua_init_texture("road_1", "data/images/lvl_forest/uudettiet/uusimetsatie1.png", h, WM_REPEAT,WM_CLAMP,AM_MODULATE)
lua_init_texture("road_2", "data/images/lvl_forest/uudettiet/uusimetsatie2.png",h,WM_CLAMP,WM_CLAMP,AM_MODULATE)
lua_init_texture("road_3", "data/images/lvl_forest/uudettiet/uusimetsatie3.png",h,WM_CLAMP,WM_CLAMP,AM_MODULATE)
lua_init_texture("reuna_test", "data/images/lvl_forest/reuna1.png", h, WM_CLAMP, WM_CLAMP, AM_MODULATE)
lua_init_texture("reuna1", "data/images/lvl_forest/reuna.png", h, WM_CLAMP, WM_CLAMP, AM_MODULATE)
lua_init_texture("reuna2", "data/images/lvl_forest/reuna2.png", h, WM_CLAMP, WM_CLAMP, AM_MODULATE)

-- props
lua_init_texture("rock_1", "data/images/lvl_forest/muut/kivi.png",h,WM_CLAMP,WM_CLAMP,AM_MODULATE)
lua_init_texture("rock_2", "data/images/lvl_forest/muut/kivi2.png",h,WM_CLAMP,WM_CLAMP,AM_MODULATE)
lua_init_texture("grass_1", "data/images/lvl_forest/grass_cartoon.png", h, WM_REPEAT,WM_CLAMP,AM_MODULATE)
lua_init_texture("grass_2", "data/images/lvl_forest/grass_cartoon2.png", h, WM_REPEAT,WM_CLAMP,AM_MODULATE)
lua_init_texture("spikes", "data/images/lvl_forest/spikes.png",h,WM_REPEAT,WM_CLAMP,AM_MODULATE)

-- background
lua_init_texture("bg_1", "data/images/lvl_forest/metsatausta.png",h,WM_REPEAT,WM_CLAMP,AM_MODULATE)
lua_init_texture("bg_2", "data/images/lvl_forest/metsatausta2.png",h,WM_REPEAT,WM_CLAMP,AM_MODULATE)

-- foreground
lua_init_texture("fg_1", "data/images/lvl_forest/foreground_1.png",h,WM_REPEAT,WM_CLAMP,AM_MODULATE)
lua_init_texture("fg_2", "data/images/lvl_forest/foreground_2.png",h,WM_REPEAT,WM_CLAMP,AM_MODULATE)
lua_init_texture("fg_3", "data/images/lvl_forest/muut/foreground1.png",h,WM_REPEAT,WM_CLAMP,AM_MODULATE)

-- 	exclamation mark
lua_init_texture("exclamationmark", "data/images/effects/huutomerkki.png",h,WM_REPEAT,WM_CLAMP,AM_MODULATE)

-- Create Level
lua:create_level(1.0,1.0,1.0,1.0)   --RGBA values are given also

-- Create Layers
-- The index of the layers are auto incremented. This meaning that the first one to add is 0 and rest are in order of appearance...
lua:create_layer(0.0,0.0,BM_DEFAULT)  -- x_scroll , y_scroll, blendmode  -- 0
lua:create_layer(0.2,0.2,BM_DEFAULT) -- 1 = taustavuoret
lua:create_layer(0.4,0.4,BM_DEFAULT) -- 2 = taustamets
lua:create_layer(0.75,0.75,BM_DEFAULT) -- 3 = lhipuita
local parallax_x = 1.0
local parallax_y = 1.0
lua:create_layer(parallax_x,parallax_y,BM_DEFAULT) -- 4
lua:create_layer(parallax_x,parallax_y,BM_DEFAULT) -- 5
lua:create_layer(1.0,1.0,BM_DEFAULT) -- 6 = fysiikka + pelaaja
lua:create_layer(1.1,1.1,BM_DEFAULT) -- 7 = joitain ruoho/kivijuttuja
lua:create_layer(1.1,1.1,BM_DEFAULT) -- 8 = foreground
lua:create_layer(1.0,1.0,BM_ADDITIVE) -- 9 = emitters
lua:create_layer(0.0,0.0,BM_DEFAULT) -- 10 = dummy, for menus

-- Background starts
local background_size = 0.20

-- background night sky 
lua:create_sprite("background", ST_TEXTURED,"background_forest", 0.0, 0.0) 
lua:sprite_shape("background",ST_TEXTURED, background_size*4096.0, background_size*2048.0)
lua:textured_sprite_tex_coords("background", ST_TEXTURED, 0.0, 0.0, 1.0, 1.0)
g_level.upload("background", 0)

-- background mountains
local bgMountainsLenght = 2.5
lua:create_sprite("background-mountains", ST_TEXTURED,"bg_1",1000.0, 80.0) -- nimi, joku, tekstuurin nimi, x, y
lua:sprite_color("background-mountains", 0.5, 0.5, 0.5 , 1.0)
lua:sprite_shape("background-mountains",ST_TEXTURED, background_size*4096.0*bgMountainsLenght, background_size*1024.0*1.5)
lua:textured_sprite_tex_coords("background-mountains", ST_TEXTURED, 0.0, -0.5, bgMountainsLenght, 1.0)
g_level.upload("background-mountains", 1)

-- background forest
local bgForestLenght = 3.5
lua:create_sprite("background-forest", ST_TEXTURED,"bg_2", 2500.0, -150.0) 
lua:sprite_color("background-forest", 0.5, 0.5, 0.5 , 1.0)
lua:sprite_shape("background-forest", ST_TEXTURED, 4096*bgForestLenght/4, 1024*1.5/4)
lua:textured_sprite_tex_coords("background-forest", ST_TEXTURED, -bgForestLenght, -0.5, 0.0, 1.0)
g_level.upload("background-forest", 2)


-- Background ends

-- lhipuut
lua:create_sprite("bgtree", ST_TEXTURED,"trees_3",              1400.0, 0.0) 
lua:sprite_shape("bgtree",ST_TEXTURED,                          200.0, 200.0)
lua:textured_sprite_tex_coords("bgtree", ST_TEXTURED,           0.0, 0.0, 1.0, 1.0)
g_level.upload("bgtree",                                        3)

lua:create_sprite("bgtree", ST_TEXTURED,"trees_2",              300.0, 100.0) 
lua:sprite_shape("bgtree",ST_TEXTURED,                          230.0, 230.0)
lua:textured_sprite_tex_coords("bgtree", ST_TEXTURED,           0.0, 0.0, 1.0, 1.0)
g_level.upload("bgtree",                                        3)


lua:create_sprite("bgtree", ST_TEXTURED,"trees_3",              2000.0, 30.0) 
lua:sprite_shape("bgtree",ST_TEXTURED,                          200.0, 200.0)
lua:textured_sprite_tex_coords("bgtree", ST_TEXTURED,           0.0, 0.0, 1.0, 1.0)
g_level.upload("bgtree",                                        3)

lua:create_sprite("bgtree", ST_TEXTURED,"trees_4",              0.0, 50.0) 
lua:sprite_shape("bgtree",ST_TEXTURED,                          200.0, 200.0)
lua:textured_sprite_tex_coords("bgtree", ST_TEXTURED,           0.0, 0.0, 1.0, 1.0)
g_level.upload("bgtree",                                        3)

lua:create_sprite("bgtree", ST_TEXTURED,"trees_4",              600, 200.0) 
lua:sprite_shape("bgtree",ST_TEXTURED,                          200.0, 200.0)
lua:textured_sprite_tex_coords("bgtree", ST_TEXTURED,           0.0, 0.0, 1.0, 1.0)
g_level.upload("bgtree",                                        3)

-- lhipuut loppuu

-- lhipuut
for i=1, 20, 1
do
lua:create_sprite("bgtree", ST_TEXTURED,"trees_4",              i*1000-50.0, 70.0) 
lua:sprite_shape("bgtree",ST_TEXTURED,                          200.0, 200.0)
lua:textured_sprite_tex_coords("bgtree", ST_TEXTURED,           0.0, 0.0, 1.0, 1.0)
g_level.upload("bgtree",                                        3)

lua:create_sprite("bgtree", ST_TEXTURED,"trees_3",              i*1000+200.0, 80.0) 
lua:sprite_shape("bgtree",ST_TEXTURED,                          200.0, 200.0)
lua:textured_sprite_tex_coords("bgtree", ST_TEXTURED,           0.0, 0.0, 1.0, 1.0)
g_level.upload("bgtree",                                        3)

lua:create_sprite("bgtree", ST_TEXTURED,"trees_2",              i*1000+500.0, 50.0) 
lua:sprite_shape("bgtree",ST_TEXTURED,                          230.0, 230.0)
lua:textured_sprite_tex_coords("bgtree", ST_TEXTURED,           0.0, 0.0, 1.0, 1.0)
g_level.upload("bgtree",                                        3)
end
lua:create_sprite("bgtree", ST_TEXTURED,"trees_1",              200.0, 90.0) 
lua:sprite_shape("bgtree",ST_TEXTURED,                          230.0, 230.0)
lua:textured_sprite_tex_coords("bgtree", ST_TEXTURED,           0.0, 0.0, 1.0, 1.0)
g_level.upload("bgtree",                                        3)

lua:create_sprite("bgtree", ST_TEXTURED,"trees_5",             -200.0, 130.0) 
lua:sprite_shape("bgtree",ST_TEXTURED,                          230.0, 230.0)
lua:textured_sprite_tex_coords("bgtree", ST_TEXTURED,           0.0, 0.0, 1.0, 1.0)
g_level.upload("bgtree",                                        3)

lua:create_sprite("bgtree", ST_TEXTURED,"trees_5",              600.0, 90.0) 
lua:sprite_shape("bgtree",ST_TEXTURED,                          230.0, 230.0)
lua:textured_sprite_tex_coords("bgtree", ST_TEXTURED,           0.0, 0.0, 1.0, 1.0)
g_level.upload("bgtree",                                        3)

lua:create_sprite("bgtree", ST_TEXTURED,"trees_7",              1800.0, 90.0) 
lua:sprite_shape("bgtree",ST_TEXTURED,                          230.0, 230.0)
lua:textured_sprite_tex_coords("bgtree", ST_TEXTURED,           0.0, 0.0, 1.0, 1.0)
g_level.upload("bgtree",                                        3)

lua:create_sprite("bgtree", ST_TEXTURED,"trees_1",              10700.0, 90.0) 
lua:sprite_shape("bgtree",ST_TEXTURED,                          230.0, 230.0)
lua:textured_sprite_tex_coords("bgtree", ST_TEXTURED,           0.0, 0.0, 1.0, 1.0)
g_level.upload("bgtree",                                        3)

lua:create_sprite("bgtree", ST_TEXTURED,"trees_7",              14800.0, 90.0) 
lua:sprite_shape("bgtree",ST_TEXTURED,                          230.0, 230.0)
lua:textured_sprite_tex_coords("bgtree", ST_TEXTURED,           0.0, 0.0, 1.0, 1.0)
g_level.upload("bgtree",                                        3)



-- background moor
for i=0, 8, 1
do
lua:create_sprite("bgtree", ST_TEXTURED,"mattaat",              i*2048, -50.0) 
lua:sprite_shape("bgtree",ST_TEXTURED,                          1024, 256.0)
lua:textured_sprite_tex_coords("bgtree", ST_TEXTURED,           0.0, 0.0, 1.0, 1.0)
g_level.upload("bgtree",                                        3)
end
-- Background ends

-- foreground 2 starts
lua:create_sprite("foreground-1", ST_TEXTURED, "fg_1", 160, -250.0)
lua:sprite_shape("foreground-1", ST_TEXTURED, 512.0, 64.0)
lua:textured_sprite_tex_coords("foreground-1", ST_TEXTURED, 0.0, 0.0, 1.0, 1.0)
g_level.upload("foreground-1", 8)

lua:create_sprite("foreground-1", ST_TEXTURED,"fg_2",1696, -250.0)
lua:sprite_shape("foreground-1",ST_TEXTURED, 1024.0, 64.0)
lua:textured_sprite_tex_coords("foreground-1", ST_TEXTURED, 0.0, 0.0, 2.0, 1.0)
g_level.upload("foreground-1", 8)

lua:create_sprite("foreground-1", ST_TEXTURED, "fg_1", 3232, -250.0)
lua:sprite_shape("foreground-1", ST_TEXTURED, 512.0, 64.0)
lua:textured_sprite_tex_coords("foreground-1", ST_TEXTURED, 0.0, 0.0, 1.0, 1.0)
g_level.upload("foreground-1", 8)

lua:create_sprite("foreground-1", ST_TEXTURED,"fg_2",4768, -250.0)
lua:sprite_shape("foreground-1",ST_TEXTURED, 1024.0, 64.0)
lua:textured_sprite_tex_coords("foreground-1", ST_TEXTURED, 0.0, 0.0, 2.0, 1.0)
g_level.upload("foreground-1", 8)

lua:create_sprite("foreground-1", ST_TEXTURED, "fg_1", 6304, -250.0)
lua:sprite_shape("foreground-1", ST_TEXTURED, 512.0, 64.0)
lua:textured_sprite_tex_coords("foreground-1", ST_TEXTURED, 0.0, 0.0, 1.0, 1.0)
g_level.upload("foreground-1", 8)

lua:create_sprite("foreground-1", ST_TEXTURED,"fg_2",7368, -250.0)
lua:sprite_shape("foreground-1",ST_TEXTURED, 1024.0, 64.0)
lua:textured_sprite_tex_coords("foreground-1", ST_TEXTURED, 0.0, 0.0, 2.0, 1.0)
g_level.upload("foreground-1", 8)

lua:create_sprite("foreground-1", ST_TEXTURED, "fg_1", 8304, -250.0)
lua:sprite_shape("foreground-1", ST_TEXTURED, 512.0, 64.0)
lua:textured_sprite_tex_coords("foreground-1", ST_TEXTURED, 0.0, 0.0, 1.0, 1.0)
g_level.upload("foreground-1", 8)

lua:create_sprite("foreground-1", ST_TEXTURED,"fg_2",9368, -250.0)
lua:sprite_shape("foreground-1",ST_TEXTURED, 1024.0, 64.0)
lua:textured_sprite_tex_coords("foreground-1", ST_TEXTURED, 0.0, 0.0, 2.0, 1.0)
g_level.upload("foreground-1", 8)

lua:create_sprite("foreground-1", ST_TEXTURED, "fg_1", 10304, -250.0)
lua:sprite_shape("foreground-1", ST_TEXTURED, 512.0, 64.0)
lua:textured_sprite_tex_coords("foreground-1", ST_TEXTURED, 0.0, 0.0, 1.0, 1.0)
g_level.upload("foreground-1", 8)

lua:create_sprite("foreground-1", ST_TEXTURED,"fg_2",11368, -250.0)
lua:sprite_shape("foreground-1",ST_TEXTURED, 1024.0, 64.0)
lua:textured_sprite_tex_coords("foreground-1", ST_TEXTURED, 0.0, 0.0, 2.0, 1.0)
g_level.upload("foreground-1", 8)

-- Foreground 2 ends


-- ** ROAD starts **

-- tasainen maa
tmp_x = 1.0
tmp_y = -128
lua:create_sprite("ylamaki", ST_TEXTURED,"tileset",             tmp_x, tmp_y) 
lua:sprite_shape("ylamaki",ST_TEXTURED,                         256.0, 128.0)
lua:textured_sprite_tex_coords("ylamaki", ST_TEXTURED,          0.0, 0.75, 0.5, 1.0)
g_level.upload("ylamaki",                                       5)

--ylamaki
tmp_x = 512+256
tmp_y = 0.0
lua:create_sprite("ylamaki", ST_TEXTURED,"tileset",             tmp_x, tmp_y) 
lua:sprite_shape("ylamaki",ST_TEXTURED,                         512.0, 256.0)
lua:textured_sprite_tex_coords("ylamaki", ST_TEXTURED,          0.0, 0.0, 1.0, 0.5)
g_level.upload("ylamaki",                                       5)

-- tasainen maa
tmp_x = 1750
tmp_y = -128
lua:create_sprite("ylamaki", ST_TEXTURED,"tileset",             tmp_x, tmp_y) 
lua:sprite_shape("ylamaki",ST_TEXTURED,                         256.0+128.0, 128.0)
lua:textured_sprite_tex_coords("ylamaki", ST_TEXTURED,          0.0, 0.5, 0.75, 0.75)
g_level.upload("ylamaki",                                       5)

-- tasainen maa
tmp_x = 1750.0+1024.0-128
tmp_y = -128
lua:create_sprite("ylamaki", ST_TEXTURED,"tileset",             tmp_x, tmp_y) 
lua:sprite_shape("ylamaki",ST_TEXTURED,                         512.0, 128.0)
lua:textured_sprite_tex_coords("ylamaki", ST_TEXTURED,          0.0, 0.75, 1.0, 1.0)
g_level.upload("ylamaki",                                       5)

-- tasainen maa loppu
tmp_x = 1750.0+1024.0+512
tmp_y = -128
lua:create_sprite("ylamaki", ST_TEXTURED,"tileset",             tmp_x, tmp_y) 
lua:sprite_shape("ylamaki",ST_TEXTURED,                         128.0, 128.0)
lua:textured_sprite_tex_coords("ylamaki", ST_TEXTURED,          0.75, 0.5, 1.0, 0.75)
g_level.upload("ylamaki",                                       5)

-- pieni maa
tmp_x = 3750
tmp_y = -260
lua:create_sprite("ylamaki", ST_TEXTURED,"tileset2",             tmp_x, tmp_y) 
lua:sprite_shape("ylamaki",ST_TEXTURED,                         128.0, 256.0)
lua:textured_sprite_tex_coords("ylamaki", ST_TEXTURED,          0.0, 0.0, 0.25, 0.5)
g_level.upload("ylamaki",                                       5)

-- pieni maa
tmp_x = 4150
tmp_y = -50
lua:create_sprite("ylamaki", ST_TEXTURED,"tileset2",             tmp_x, tmp_y) 
lua:sprite_shape("ylamaki",ST_TEXTURED,                         128.0, 256.0)
lua:textured_sprite_tex_coords("ylamaki", ST_TEXTURED,          0.0, 0.0, 0.25, 0.5)
g_level.upload("ylamaki",                                       5)

-- pieni maa
tmp_x = 4650
tmp_y = 60
lua:create_sprite("ylamaki", ST_TEXTURED,"tileset2",             tmp_x, tmp_y) 
lua:sprite_shape("ylamaki",ST_TEXTURED,                         128.0, 256.0)
lua:textured_sprite_tex_coords("ylamaki", ST_TEXTURED,          0.0, 0.0, 0.25, 0.5)
g_level.upload("ylamaki",                                       5)


--alamaki
tmp_x = 5000+512
tmp_y = 50.0
lua:create_sprite("ylamaki", ST_TEXTURED,"tileset",             tmp_x, tmp_y) 
lua:sprite_shape("ylamaki",ST_TEXTURED,                         512.0, 256.0)
lua:textured_sprite_tex_coords("ylamaki", ST_TEXTURED,          1.0, 0.0, 0.0, 0.5)
g_level.upload("ylamaki",                                       5)

--alamaki fix
tmp_x = 5000+512
tmp_y = 50.0-512
lua:create_sprite("ylamaki", ST_TEXTURED,"tileset",             tmp_x, tmp_y) 
lua:sprite_shape("ylamaki",ST_TEXTURED,                         512.0, 256.0)
lua:textured_sprite_tex_coords("ylamaki", ST_TEXTURED,          1.0, 0.5, 0.0, 0.0)
g_level.upload("ylamaki",                                       5)

tmp_x = 5000+512+512+128
tmp_y = 50.0-128
lua:create_sprite("ylamaki", ST_TEXTURED,"tileset",             tmp_x, tmp_y) 
lua:sprite_shape("ylamaki",ST_TEXTURED,                         128.0, 128.0)
lua:textured_sprite_tex_coords("ylamaki", ST_TEXTURED,          0.75, 0.5, 1.0, 0.75)
g_level.upload("ylamaki",                                       5)

tmp_x = 5000+512+512+128
tmp_y = 50.0-128-128-128
lua:create_sprite("ylamaki", ST_TEXTURED,"tileset",             tmp_x, tmp_y) 
lua:sprite_shape("ylamaki",ST_TEXTURED,                         128.0, 128.0)
lua:textured_sprite_tex_coords("ylamaki", ST_TEXTURED,          0.75, 0.75, 1.0, 0.5)
g_level.upload("ylamaki",                                       5)
-- pieni maa
tmp_x = 6630
tmp_y = -160
lua:create_sprite("ylamaki", ST_TEXTURED,"tileset2",             tmp_x, tmp_y) 
lua:sprite_shape("ylamaki",ST_TEXTURED,                         128.0, 256.0)
lua:textured_sprite_tex_coords("ylamaki", ST_TEXTURED,          0.0, 0.0, 0.25, 0.5)
g_level.upload("ylamaki",                                       5)

-- pieni maa
tmp_x = 7100
tmp_y = 10
lua:create_sprite("ylamaki", ST_TEXTURED,"tileset2",             tmp_x, tmp_y) 
lua:sprite_shape("ylamaki",ST_TEXTURED,                         128.0, 256.0)
lua:textured_sprite_tex_coords("ylamaki", ST_TEXTURED,          0.0, 0.0, 0.25, 0.5)
g_level.upload("ylamaki",                                       5)

-- pieni maa
tmp_x = 7700
tmp_y = 60
lua:create_sprite("ylamaki", ST_TEXTURED,"tileset2",             tmp_x, tmp_y) 
lua:sprite_shape("ylamaki",ST_TEXTURED,                         128.0, 256.0)
lua:textured_sprite_tex_coords("ylamaki", ST_TEXTURED,          0.0, 0.0, 0.25, 0.5)
g_level.upload("ylamaki",                                       5)


-- pieni maa
tmp_x = 8300
tmp_y = -100
lua:create_sprite("ylamaki", ST_TEXTURED,"tileset2",             tmp_x, tmp_y) 
lua:sprite_shape("ylamaki",ST_TEXTURED,                         128.0, 256.0)
lua:textured_sprite_tex_coords("ylamaki", ST_TEXTURED,          0.0, 0.0, 0.25, 0.5)
g_level.upload("ylamaki",                                       5)

-- tasainen maa
tmp_x = 9000
tmp_y = -128
lua:create_sprite("ylamaki", ST_TEXTURED,"tileset",             tmp_x, tmp_y) 
lua:sprite_shape("ylamaki",ST_TEXTURED,                         256.0+128.0, 128.0)
lua:textured_sprite_tex_coords("ylamaki", ST_TEXTURED,          0.0, 0.5, 0.75, 0.75)
g_level.upload("ylamaki",                                       5)

-- tasainen maa
tmp_x = 9000.0+1024.0-128
tmp_y = -128
lua:create_sprite("ylamaki", ST_TEXTURED,"tileset",             tmp_x, tmp_y) 
lua:sprite_shape("ylamaki",ST_TEXTURED,                         512.0, 128.0)
lua:textured_sprite_tex_coords("ylamaki", ST_TEXTURED,          0.0, 0.75, 1.0, 1.0)
g_level.upload("ylamaki",                                       5)

-- tasainen maa loppu
tmp_x = 9000.0+1024.0+512
tmp_y = -128
lua:create_sprite("ylamaki", ST_TEXTURED,"tileset",             tmp_x, tmp_y) 
lua:sprite_shape("ylamaki",ST_TEXTURED,                         128.0, 128.0)
lua:textured_sprite_tex_coords("ylamaki", ST_TEXTURED,          0.75, 0.5, 1.0, 0.75)
g_level.upload("ylamaki",                                       5)

-- ** road end **
-- kyltti
tmp_x = 10000
tmp_y = -60.0
lua:create_sprite("ylamaki", ST_TEXTURED,"sign2",             tmp_x, tmp_y) 
lua:sprite_shape("ylamaki",ST_TEXTURED,                         64, 64)
lua:textured_sprite_tex_coords("ylamaki", ST_TEXTURED,          0.0, 0.0, 1.0, 1.0)
g_level.upload("ylamaki",                                       4)
--Roads end


-- ** esteet starts

--EMITTER_BULLET start
lua:do_file("data/scripts/inc_emitter_bullet.lua")
--YLS ALAS--
pos_x = 6250
pos_y = -120
spd = 0.125
local path_list = {}
table.insert(path_list,{pos_x,pos_y,0.0})
table.insert(path_list,{pos_x,pos_y+400,0.5})
table.insert(path_list,{pos_x,pos_y,1.0})
create_emitter_bullet(path_list,true,spd,9)--path_list, is_repeating,speed, layer	
--YMPYR--
pos_x = 7100
pos_y = 140
spd = 0.1
angles = 24;
radius = 200;
local path_list = {}
for i=0, angles ,1 do
    local pos_xx = pos_x + math.sin( i*math.pi/ (angles/2) )*radius
    local pos_yy = pos_y + math.cos( i*math.pi/ (angles/2) )*radius
    local time = i*1.0 / angles     	
    table.insert(path_list,{pos_xx,pos_yy,time}) --x,y,time
end   
create_emitter_bullet(path_list,true,spd,9)--path_list, is_repeating,speed, layer		
--YMPYR--
pos_x = 7700
pos_y = 140
spd = 0.1
angles = 24;
radius = 200;
local path_list = {}
for i=0, angles ,1 do
    local pos_xx = pos_x + math.sin( i*math.pi/ (angles/2) )*radius
    local pos_yy = pos_y + math.cos( i*math.pi/ (angles/2) )*radius
    local time = i*1.0 / angles     	
    table.insert(path_list,{pos_xx,pos_yy,time}) --x,y,time
end   
create_emitter_bullet(path_list,true,spd,9)--path_list, is_repeating,speed, layer		
	


--TAPPAJAT
balls = 3
y_range_from = -100
y_range_to = 300

for b=0,balls,1 do
    --YMPYR--
    steps = 120
    from_x = -700 + math.random(-500,500)
    to_x = 10000
    from_y = y_range_from + (y_range_to-y_range_from)/balls*b
    to_y = from_y
    spd = time_to_remo_speed(60)
    radius = 200;
    local pos_list = {}
    local path_list = {}

    --calculate position with the moving axis
    for i=1, steps,1 do
        local x = from_x + ((to_x - from_x)/steps)*i
        local y = from_y + ((to_y - from_y)/steps)*i
        table.insert(pos_list,{x,y})
    end

    --wavelength = 500
    --k = (2*math.pi)/wavelength
    k = 1.0
    for i=1,steps,1 do
        local tmp = pos_list[i]
        local pos_xx = tmp[1]
        local pos_yy = radius * math.sin(k*tmp[1]-(math.pi*i)+(50*b)) + tmp[2]
        local time = i*1.0 / steps
        table.insert(path_list,{pos_xx,pos_yy,time}) --x,y,time
    end
    
    create_super_emitter_bullet(path_list,true,spd,9)--path_list, is_repeating,speed, layer
end

-- ** esteet end




-- jumping trees start
-- ...                                      4)
-- jumping trees ends


-- spikes start
-- ...
-- spikes end


-- ** Segments start **

lua:create_segment(-345, -400)
lua:add_segment(8095, -400)
lua:upload_segmentstrip()

lua:create_segment(-95.0646, -68.4453)
lua:add_segment(8.93536, -69.4453)
lua:add_segment(115.935, -104.445)
lua:add_segment(222.935, -128.445)
lua:add_segment(278.935, -120.445)
lua:add_segment(393.935, -72.4453)
lua:add_segment(458.935, -66.4453)
lua:add_segment(508.935, -39.4453)
lua:add_segment(544.935, -30.4453)
lua:add_segment(651.935, 13.5547)
lua:add_segment(715.935, 19.5547)
lua:add_segment(768.935, 50.5547)
lua:add_segment(786.935, 50.5547)
lua:add_segment(893.935, 95.5547)
lua:add_segment(966.935, 108.555)
lua:add_segment(1023.94, 130.555)
lua:add_segment(1034.04, 128.105)

lua:upload_segmentstrip()

lua:create_segment(1613.04, -123.115)
lua:add_segment(1727.04, -168.115)
lua:add_segment(1828.04, -184.115)
lua:add_segment(1926.04, -179.115)
lua:add_segment(2058.04, -149.115)
lua:add_segment(2133.04, -123.115)
lua:add_segment(2259.48, -79.1149)
lua:add_segment(2350.48, -70.1149)
lua:add_segment(2440.48, -87.1148)
lua:add_segment(2527.48, -110.115)
lua:add_segment(2610.48, -126.115)
lua:add_segment(2643.48, -128.115)
lua:add_segment(2705.48, -137.115)
lua:add_segment(2761.48, -151.115)
lua:add_segment(2869.48, -153.115)
lua:add_segment(2996.48, -144.115)
lua:add_segment(3114.48, -131.115)
lua:add_segment(3170.48, -129.115)
lua:upload_segmentstrip()

lua:create_segment(3688.1, -135.13)
lua:add_segment(3701.1, -129.13)
lua:add_segment(3797.1, -131.13)
lua:add_segment(3804.1, -139.13)
lua:upload_segmentstrip()

lua:create_segment(4092.1, 69.8698)
lua:add_segment(4098.1, 77.8698)
lua:add_segment(4201.1, 75.8698)
lua:add_segment(4207.1, 68.8698)
lua:upload_segmentstrip()

lua:create_segment(4591.1, 182.87)
lua:add_segment(4598.1, 192.87)
lua:add_segment(4701.1, 187.87)
lua:add_segment(4707.1, 177.87)
lua:upload_segmentstrip()

-- alamki
lua:create_segment(5237.96, 178.891)
lua:add_segment(5254.96, 181.891)
lua:add_segment(5315.96, 154.891)
lua:add_segment(5386.96, 141.891)
lua:add_segment(5828.96, -10.1087)
lua:add_segment(5889.96, -26.1087)
lua:add_segment(6000.96, -70.1087)
lua:add_segment(6034.96, -72.1087)
lua:add_segment(6043.96, -81.1087)
lua:upload_segmentstrip()

--pieni maa
lua:create_segment(6571.55, -31.2517)
lua:add_segment(6581.55, -20.2518)
lua:add_segment(6677.55, -24.2518)
lua:add_segment(6683.55, -34.2518)
lua:upload_segmentstrip()


--pieni maa
lua:create_segment(7042.69, 134.601)
lua:add_segment(7051.69, 141.601)
lua:add_segment(7150.69, 139.601)
lua:add_segment(7157.69, 129.601)
lua:upload_segmentstrip()

--pieni maa
lua:create_segment(7640.67, 185.827)
lua:add_segment(7651.45, 194.827)
lua:add_segment(7751.04, 188.827)
lua:add_segment(7757.95, 175.827)
lua:upload_segmentstrip()

--pieni maa
lua:create_segment(8231.93, 25.8267)
lua:add_segment(8242.93, 33.8267)
lua:add_segment(8349.93, 28.8267)
lua:add_segment(8355.93, 18.8267)
lua:upload_segmentstrip()

--apu
lua:create_segment(2717.43, -161.576)
lua:add_segment(2940.43, -306.576)
lua:upload_segmentstrip()
lua:create_segment(5827.31, -33.2237)
lua:add_segment(5905.31, -213.224)
lua:add_segment(6052.31, -305.224)
lua:upload_segmentstrip()

--tasainen maa
lua:create_segment(8857.67, -135.421)
lua:add_segment(8878.67, -131.421)
lua:add_segment(8926.42, -142.421)
lua:add_segment(9042.87, -183.421)
lua:add_segment(9163.76, -180.421)
lua:add_segment(9381.75, -125.421)
lua:add_segment(9554.75, -71.4207)
lua:add_segment(9662.75, -74.4207)
lua:add_segment(9864.75, -125.421)
lua:add_segment(10019.2, -150.421)
lua:add_segment(10135.8, -150.421)
lua:add_segment(10385.5, -126.421)
lua:add_segment(10420.9, -125.421)
lua:add_segment(10426.1, -136.421)
lua:upload_segmentstrip()

-- ** Segmetns end **

--BATS
lua:do_file("data/scripts/inc_bats.lua")
local path = {}
table.insert(path,{1816, 27})
table.insert(path,{2331, 98})
table.insert(path,{2860, 54})
table.insert(path,{3060, 42})
create_moving_bat(path, false,6)
--create still bat
create_still_bat(1504, 261,false,6)
create_still_bat(3381, 28,false,6)
create_still_bat(6286, -73,false,6)
create_still_bat(5657, 305,false,6)
create_still_bat(4985, 183,false,6)

--STOPPERS start
stopper(LEFT,-96.0) --direction, x
stopper(RIGHT,10400.0) --direction, x
--STOPPERS end

--Triggers start
--finished
trigger("data/scripts/srt_level_finished.lua","",40,1000,10320,123) --script, width, height, x, y
--secure kill
trigger("data/scripts/srt_game_over.lua","",20000,100,5820,-450) --script, width, height, x, y

--Triggers end


--Player
--INIT PLAYER
lua:do_file("data/scripts/crt_player_trigger.lua",0)
lua:init_camera_binder(-96.0, 10300.0, -312.0, 1000.0) -- left, right, bottom, up
lua:upload_player_to_layer(6)  --index of the layer
lua:creature_translation("player", CPT_PLAYER, 600.0,200.0) -- set the player to it's right position
--Player end

--INIT POINT SETTINGS
lua:points_reset(58, 6) --par_time (the time to be aimed for, in seconds), max_combo (maximum amount of bats in the map)
lua:add_point_level("poor",40) -- description of success, points
lua:add_point_level("average",80)
lua:add_point_level("good",100)
lua:add_point_level("perfect",110)
lua:add_point_level("insane",150)
lua:timer_start() --starts the timer for the level HOX: HAS TO BE LAST!!!

lua:set_game_state(GS_PLAY) -- sets the game state to menu. thus you are able to use the menu commands
g_level.next_level = "data/scripts/lvl_city.lua"
lua:do_file("data/scripts/srt_mission_forest_accomplished.lua")--mission forest accomplished
g_level.set_level("data/scripts/lvl_testi.lua")

comes_from_impossible_forest = true

fade_in(3)