--TODO: tee nist moduuleja joita voi kytt luokkien tapaan...
require 'g_level'
require 'g_sewer_aid'
g_level.reset()

fade_in(2)
--INIT TEXTURES  -- adds a texture into ObjectManager<Texture>
h = FM_NEAREST;

-- textures
lua_init_texture("sewer_tileset", "data/images/sewer/sewer_tileset.png", h, WM_REPEAT,WM_CLAMP,AM_MODULATE)
lua_init_texture("sewer_tileset2", "data/images/sewer/sewer_tileset2.png", h, WM_REPEAT,WM_CLAMP,AM_MODULATE)
lua_init_texture("sewer_objects", "data/images/sewer/sewer_objects_1.png",h,WM_REPEAT,WM_CLAMP,AM_MODULATE)
lua_init_texture("sewer_steam", "data/images/sewer/steam.png",h,WM_REPEAT,WM_CLAMP,AM_MODULATE)
lua_init_texture("sewer_unstable_floor", "data/images/sewer/frac_grnd_holder.png",h,WM_REPEAT,WM_CLAMP,AM_MODULATE)
lua_init_texture("map4", "data/images/sewer/maps/map_4.png",h,WM_REPEAT,WM_CLAMP,AM_MODULATE)
lua_init_texture("sewer_fore", "data/images/sewer/sewer_fore.png",h,WM_REPEAT,WM_CLAMP,AM_MODULATE)
lua_init_texture("barrel", "data/images/sewer/broken_barrel.png",h,WM_REPEAT,WM_CLAMP,AM_MODULATE)
lua_init_texture("drop", "data/images/sewer/drop.png",h,WM_REPEAT,WM_CLAMP,AM_MODULATE)

-- Create Level
lua:create_level(1.0,1.0,1.0,1.0)   --RGBA values are given also


-- Create Layers
-- The index of the layers are auto incremented. This meaning that the first one to add is 0 and rest are in order of appearance...
lua:create_layer(0.0,0.0,BM_DEFAULT)  -- x_scroll , y_scroll, blendmode  -- 0
lua:create_layer(0.2,0.2,BM_DEFAULT) -- 1 = taustavuoret
lua:create_layer(0.4,0.4,BM_DEFAULT) -- 2 = taustamets
lua:create_layer(0.75,0.75,BM_DEFAULT) -- 3 = lhipuita
local parallax_x = 1.0
local parallax_y = 1.0

local kamerapurkka = 1.0; --kun pelaaja on kentalla 1.0 ja rakenteluvaiheessa 0.1

lua:create_layer(parallax_x,parallax_y,BM_DEFAULT) -- 4
lua:create_layer(parallax_x,parallax_y,BM_DEFAULT) -- 5
lua:create_layer(kamerapurkka , kamerapurkka ,BM_DEFAULT) -- 6 = fysiikka + pelaaja
lua:create_layer(1.0,1.0,BM_DEFAULT) -- 7 = joitain ruoho/kivijuttuja
lua:create_layer(1.3,1.3,BM_DEFAULT) -- 8 = foreground
lua:create_layer(0.0,0.0,BM_DEFAULT) -- 9 = dummy, for menus


lua:layer_color(6, 5.2, 5.2, 5.2, 1.0)
local tileSize = 256*(2/3)
local mainY = 0.0;

-- Fore Graphics
lua:create_sprite("sewer", ST_TEXTURED,"sewer_fore", 1024.0+512.0, 0.0) -- nimi, joku, tekstuurin nimi, x, y
lua:sprite_color("sewer", 0.2, 0.2, 0.2 , 1.0)
lua:sprite_shape("sewer",ST_TEXTURED, 3*tileSize*12, tileSize*3)
lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.0, 0.0, 3.0, 1.0)
g_level.upload("sewer", 8)
lua:create_sprite("sewer", ST_TEXTURED,"sewer_fore", 1024.0+512.0, 1024.0) -- nimi, joku, tekstuurin nimi, x, y
lua:sprite_color("sewer", 0.2, 0.2, 0.2 , 1.0)
lua:sprite_shape("sewer",ST_TEXTURED, 3*tileSize*12, tileSize*3)
lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.0, 1.0, 3.0, 0.0)
g_level.upload("sewer", 8)

-- Main tiles


-- Basic
lua:create_sprite("sewer", ST_TEXTURED,"sewer_tileset", tileSize*-2, mainY) -- nimi, joku, tekstuurin nimi, x, y
lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 1.0)
lua:sprite_shape("sewer",ST_TEXTURED, tileSize, tileSize*2)
lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.0, 0.5, 0.25, 1.0)
g_level.upload("sewer", 6)

-- Wall ending
lua:create_sprite("sewer", ST_TEXTURED,"sewer_tileset",0.0, mainY) -- nimi, joku, tekstuurin nimi, x, y
lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 1.0)
lua:sprite_shape("sewer",ST_TEXTURED, tileSize, tileSize*2)
lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.75, 0.0, 1.0, 0.5)
g_level.upload("sewer", 6)

-- Enterance
lua:create_sprite("sewer", ST_TEXTURED,"sewer_tileset", tileSize*3, mainY) -- nimi, joku, tekstuurin nimi, x, y
lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 1.0)
lua:sprite_shape("sewer",ST_TEXTURED, tileSize*2, tileSize*2)
lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.5, 0.5, 1.0, 1.0)
g_level.upload("sewer", 6)


-- Basic
lua:create_sprite("sewer", ST_TEXTURED,"sewer_tileset", tileSize*6, mainY) -- nimi, joku, tekstuurin nimi, x, y
lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 1.0)
lua:sprite_shape("sewer",ST_TEXTURED, tileSize, tileSize*2)
lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.0, 0.5, 0.25, 1.0)
g_level.upload("sewer", 6)


-- Gap start
lua:create_sprite("sewer", ST_TEXTURED,"sewer_tileset", tileSize*8, mainY) -- nimi, joku, tekstuurin nimi, x, y
lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 1.0)
lua:sprite_shape("sewer",ST_TEXTURED, tileSize, tileSize*2)
lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.0, 0.0, 0.25, 0.5)
g_level.upload("sewer", 6)

-- Gap
lua:create_sprite("sewer", ST_TEXTURED,"sewer_tileset", tileSize*10, mainY) -- nimi, joku, tekstuurin nimi, x, y
lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 1.0)
lua:sprite_shape("sewer",ST_TEXTURED, tileSize, tileSize*2)
lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.25, 0.0, 0.5, 0.5)
g_level.upload("sewer", 6)

-- Gap end
lua:create_sprite("sewer", ST_TEXTURED,"sewer_tileset", tileSize*12, mainY) -- nimi, joku, tekstuurin nimi, x, y
lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 1.0)
lua:sprite_shape("sewer",ST_TEXTURED, tileSize, tileSize*2)
lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.5, 0.0, 0.75, 0.5)
g_level.upload("sewer", 6)


-- Wall ending
lua:create_sprite("sewer", ST_TEXTURED,"sewer_tileset", tileSize*13, mainY) -- nimi, joku, tekstuurin nimi, x, y
lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 1.0)
lua:sprite_shape("sewer",ST_TEXTURED, tileSize, tileSize*2)
lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.75, 0.0, 1.0, 0.5)
g_level.upload("sewer", 6)

-- Enterance
lua:create_sprite("sewer", ST_TEXTURED,"sewer_tileset", tileSize*16, mainY) -- nimi, joku, tekstuurin nimi, x, y
lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 1.0)
lua:sprite_shape("sewer",ST_TEXTURED, tileSize*2, tileSize*2)
lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.5, 0.5, 1.0, 1.0)
g_level.upload("sewer", 6)

-- Basic
lua:create_sprite("sewer", ST_TEXTURED,"sewer_tileset", tileSize*19, mainY) -- nimi, joku, tekstuurin nimi, x, y
lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 1.0)
lua:sprite_shape("sewer",ST_TEXTURED, tileSize, tileSize*2)
lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.0, 0.5, 0.25, 1.0)
g_level.upload("sewer", 6)

-- Basic
lua:create_sprite("sewer", ST_TEXTURED,"sewer_tileset", tileSize*21, mainY) -- nimi, joku, tekstuurin nimi, x, y
lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 1.0)
lua:sprite_shape("sewer",ST_TEXTURED, tileSize, tileSize*2)
lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.0, 0.5, 0.25, 1.0)
g_level.upload("sewer", 6)

-- Basic
lua:create_sprite("sewer", ST_TEXTURED,"sewer_tileset", tileSize*23, mainY) -- nimi, joku, tekstuurin nimi, x, y
lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 1.0)
lua:sprite_shape("sewer",ST_TEXTURED, tileSize, tileSize*2)
lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.0, 0.5, 0.25, 1.0)
g_level.upload("sewer", 6)

-- Enterance
lua:create_sprite("sewer", ST_TEXTURED,"sewer_tileset", tileSize*25, mainY) -- nimi, joku, tekstuurin nimi, x, y
lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 1.0)
lua:sprite_shape("sewer",ST_TEXTURED, tileSize*2, tileSize*2)
lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.5, 0.5, 1.0, 1.0)
g_level.upload("sewer", 6)


-- Wall ending
lua:create_sprite("sewer", ST_TEXTURED,"sewer_tileset",tileSize*28, mainY) -- nimi, joku, tekstuurin nimi, x, y
lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 1.0)
lua:sprite_shape("sewer",ST_TEXTURED, tileSize, tileSize*2)
lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.75, 0.0, 1.0, 0.5)
g_level.upload("sewer", 6)

-- Basic
lua:create_sprite("sewer", ST_TEXTURED,"sewer_tileset", tileSize*30, mainY) -- nimi, joku, tekstuurin nimi, x, y
lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 1.0)
lua:sprite_shape("sewer",ST_TEXTURED, tileSize, tileSize*2)
lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.0, 0.5, 0.25, 1.0)
g_level.upload("sewer", 6)


-- Main tiles end

-- Map
lua:create_sprite("sewer", ST_TEXTURED,"map4", 3000.0, 160.0) -- nimi, joku, tekstuurin nimi, x, y
lua:sprite_color("sewer", 0.2, 0.2, 0.2 , 1.0)
lua:sprite_shape("sewer",ST_TEXTURED, tileSize/2, tileSize/2)
lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.0, 0.0, 1.0, 1.0)
g_level.upload("sewer", 6)



-- Ground (upper)
groundLenght = 4
for i=0,groundLenght,1 
do
    lua:create_sprite("sewer", ST_TEXTURED,"sewer_tileset2", i*tileSize*8+tileSize*1, mainY+tileSize*3-2) -- nimi, joku, tekstuurin nimi, x, y
    lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 1.0)
    lua:sprite_shape("sewer",ST_TEXTURED, tileSize*4, tileSize)
    lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.0, 0.25, 1.0, 0.5)
    g_level.upload("sewer", 6)
end
-- Ground end


--running water start
local waterLenght = 5;
local waterSpdY= 0.1;
local waterY = -150;
for i=1,waterLenght,1 
do
    local waterX = -1600+i*tileSize*8*1.5

    lua:create_sprite("sewer", ST_SCROLLING,"sewer_tileset2", waterX, waterY) -- nimi, joku, tekstuurin nimi, x, y
    lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 0.3)
    lua:sprite_shape("sewer",ST_SCROLLING, tileSize*1.5*4, tileSize*1*1.5)
    lua:textured_sprite_tex_coords("sewer", ST_SCROLLING, 0.0, 0.0, 1.0, 0.25) --0.75, 0.0, 1.0, 0.15
    lua:scrolling_sprite("sewer", SS_HORIZONTAL, 0.03) -- name. type of scrolling. scrolling speed
    lua:remorfable_sprite("water", "sewer", waterSpdY, true)             -- name, sprite_name, speed, repeat

    lua:add_key_frame(0.5, waterX, waterY-30, 0.0, 1.0)  -- adds a new key frame. time, x, y, rotation, scale
    lua:add_key_frame_color(1.0,1.0,1.0,0.3)  -- r,g,b,a
    lua:upload_key_frame("water")
    
    g_level.upload("water", 6)
    
    --**2**	
    lua:create_sprite("sewer", ST_SCROLLING,"sewer_tileset2", waterX, waterY-50) -- nimi, joku, tekstuurin nimi, x, y
    lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 0.2)
    lua:sprite_shape("sewer",ST_SCROLLING, tileSize*1.5*4, tileSize*1*1.5)
    lua:textured_sprite_tex_coords("sewer", ST_SCROLLING, 0.0, 0.0, 1.0, 0.25) --0.75, 0.0, 1.0, 0.15
    lua:scrolling_sprite("sewer", SS_HORIZONTAL, 0.02) -- name. type of scrolling. scrolling speed
    lua:remorfable_sprite("water", "sewer", waterSpdY/2, true)             -- name, sprite_name, speed, repeat

    lua:add_key_frame(0.5, waterX, waterY-20, 0.0, 1.0)  -- adds a new key frame. time, x, y, rotation, scale
    lua:add_key_frame_color(1.0,1.0,1.0,0.2)  -- r,g,b,a
    lua:upload_key_frame("water")
    
    g_level.upload("water", 6)
    -- **3**
    lua:create_sprite("sewer", ST_SCROLLING,"sewer_tileset2", waterX, waterY-100) -- nimi, joku, tekstuurin nimi, x, y
    lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 0.2)
    lua:sprite_shape("sewer",ST_SCROLLING, tileSize*1.5*4, tileSize*1*1.5)
    lua:textured_sprite_tex_coords("sewer", ST_SCROLLING, 0.0, 0.0, 1.0, 0.25) --0.75, 0.0, 1.0, 0.15
    lua:scrolling_sprite("sewer", SS_HORIZONTAL, 0.025) -- name. type of scrolling. scrolling speed
    lua:remorfable_sprite("water", "sewer", waterSpdY/2, true)             -- name, sprite_name, speed, repeat

    lua:add_key_frame(0.5, waterX, waterY-100, 0.0, 1.0)  -- adds a new key frame. time, x, y, rotation, scale
    lua:add_key_frame_color(1.0,1.0,1.0,0.2)  -- r,g,b,a
    lua:upload_key_frame("water")
    
    g_level.upload("water", 6)

    
end
--running water end

-- steam start
local steamGap = 100
local steamLenght=50

for j=0,2,1
do 
    for i=0,steamLenght,1 
    do
        local steamPlace = 0+steamGap*i
        local steamSpd = math.random()/20 + 0.05
        
        lua:create_sprite("steam", ST_TEXTURED,"sewer_steam", steamPlace, -256.0*1.5) 
        lua:sprite_shape("steam",ST_TEXTURED, 64.0, 64.0)
        lua:textured_sprite_tex_coords("steam", ST_TEXTURED,0.0, 0.0, 1.0, 1.0)
        lua:remorfable_sprite("st", "steam", steamSpd, true)             -- name, sprite_name, speed, repeat

        lua:add_key_frame(0.0, steamPlace, -256.0*1.5, 0.0, 1.0)  -- adds a new key frame. time, x, y, rotation, scale
        lua:add_key_frame_color(1.0,1.0,1.0,0.4)  -- r,g,b,a
        lua:upload_key_frame("st")

        lua:add_key_frame(1.0, steamPlace, 0.0, 0.0, 2.0)  -- adds a new key frame. time, x, y, rotation, scale
        lua:add_key_frame_color(1.0,1.0,1.0,0.0)  -- r,g,b,a
        lua:upload_key_frame("st")

        g_level.upload("st",6)
    end
end
-- steam end



-- Objects

    -- box1
    lua:create_sprite("sewer", ST_TEXTURED,"sewer_objects", tileSize*18, 0.0) -- nimi, joku, tekstuurin nimi, x, y
    lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 1.0)
    lua:sprite_shape("sewer",ST_TEXTURED, tileSize/4, tileSize/4)
    lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.0, 0.75, 0.25, 1.0)
    g_level.upload("sewer", 6)
    
    -- box1
    lua:create_sprite("sewer", ST_TEXTURED,"sewer_objects",tileSize*18+80, -10.0) -- nimi, joku, tekstuurin nimi, x, y
    lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 1.0)
    lua:sprite_shape("sewer",ST_TEXTURED, tileSize/4, tileSize/4)
    lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.25, 0.75, 0.5, 1.0)
    g_level.upload("sewer", 6)
    
    -- box2
    lua:create_sprite("sewer", ST_TEXTURED,"sewer_objects",tileSize*18+40, 40.0) -- nimi, joku, tekstuurin nimi, x, y
    lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 1.0)
    lua:sprite_shape("sewer",ST_TEXTURED, tileSize/4, tileSize/4)
    lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.25, 0.75, 0.5, 1.0)
    g_level.upload("sewer", 6)


    
      -- box1
    lua:create_sprite("sewer", ST_TEXTURED,"sewer_objects", tileSize*19+100, 0.0) -- nimi, joku, tekstuurin nimi, x, y
    lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 1.0)
    lua:sprite_shape("sewer",ST_TEXTURED, tileSize/4, tileSize/4)
    lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.0, 0.75, 0.25, 1.0)
    g_level.upload("sewer", 6)
    
    -- box1
    lua:create_sprite("sewer", ST_TEXTURED,"sewer_objects",tileSize*19+80+100, -10.0) -- nimi, joku, tekstuurin nimi, x, y
    lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 1.0)
    lua:sprite_shape("sewer",ST_TEXTURED, tileSize/4, tileSize/4)
    lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.25, 0.75, 0.5, 1.0)
    g_level.upload("sewer", 6)
    
    -- box2
    lua:create_sprite("sewer", ST_TEXTURED,"sewer_objects",tileSize*19+40+100, 40.0) -- nimi, joku, tekstuurin nimi, x, y
    lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 1.0)
    lua:sprite_shape("sewer",ST_TEXTURED, tileSize/4, tileSize/4)
    lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.25, 0.75, 0.5, 1.0)
    g_level.upload("sewer", 6)


    -- box1
    lua:create_sprite("sewer", ST_TEXTURED,"sewer_objects", tileSize*19+180+70, -10.0) -- nimi, joku, tekstuurin nimi, x, y
    lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 1.0)
    lua:sprite_shape("sewer",ST_TEXTURED, tileSize/4, tileSize/4)
    lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.0, 0.75, 0.25, 1.0)
    g_level.upload("sewer", 6)
    
     -- box1
    lua:create_sprite("sewer", ST_TEXTURED,"sewer_objects", tileSize*19+260+70, -10.0) -- nimi, joku, tekstuurin nimi, x, y
    lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 1.0)
    lua:sprite_shape("sewer",ST_TEXTURED, tileSize/4, tileSize/4)
    lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.0, 0.75, 0.25, 1.0)
    g_level.upload("sewer", 6)
    
    -- box2
    lua:create_sprite("sewer", ST_TEXTURED,"sewer_objects",tileSize*19+210+70, 40.0) -- nimi, joku, tekstuurin nimi, x, y
    lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 1.0)
    lua:sprite_shape("sewer",ST_TEXTURED, tileSize/4, tileSize/4)
    lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.25, 0.75, 0.5, 1.0)
    g_level.upload("sewer", 6)

    -- box2
    lua:create_sprite("sewer", ST_TEXTURED,"sewer_objects", tileSize*19+210, 40.0) -- nimi, joku, tekstuurin nimi, x, y
    lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 1.0)
    lua:sprite_shape("sewer",ST_TEXTURED, tileSize/4, tileSize/4)
    lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.0, 0.75, 0.25, 1.0)
    g_level.upload("sewer", 6)	

    -- barrel3
    lua:create_sprite("sewer", ST_TEXTURED,"sewer_objects", tileSize*19+240, 90.0) -- nimi, joku, tekstuurin nimi, x, y
    lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 1.0)
    lua:sprite_shape("sewer",ST_TEXTURED, tileSize/4, tileSize/4)
    lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.0, 0.5, 0.25, 0.75)
    g_level.upload("sewer", 6)

    -- barrel fallen
    lua:create_sprite("sewer", ST_TEXTURED,"sewer_objects", tileSize*22, -10.0) -- nimi, joku, tekstuurin nimi, x, y
    lua:sprite_color("sewer", 1.0, 1.0, 1.0 , 1.0)
    lua:sprite_shape("sewer",ST_TEXTURED, tileSize/4, tileSize/4)
    lua:textured_sprite_tex_coords("sewer", ST_TEXTURED, 0.25, 0.5, 0.5, 0.75)
    g_level.upload("sewer", 6)

-- Objects end


--STOPPERS
--walls
stopper(LEFT,76) --far left
--second
lua:create_shape("generic_name_vol1",PSC_RECTANGLE,123/2,1000.0) -- name, type, width, height
lua:create_collider(1111,"generic_name_vol1",2243.5,0.0) --id, shape, x ,y
--far right
stopper(RIGHT,4739.0) --id, shape, x ,y


--Segments start
lua:create_segment(-254.696, -37)
lua:add_segment(423.304, -37)
lua:add_segment(433.304, -45)
lua:upload_segmentstrip()

lua:create_segment(550.609, -41)
lua:add_segment(555.609, -37)
lua:add_segment(1508.61, -36)
lua:add_segment(1514.61, -42)
lua:upload_segmentstrip()

lua:create_segment(1886.84, -42)
lua:add_segment(1893.84, -34)
lua:add_segment(2651.84, -35)
lua:add_segment(2655.84, -42)
lua:upload_segmentstrip()

lua:create_segment(2777.62, -37.154)
lua:add_segment(2781.83, -25.154)
lua:add_segment(4187.13, -30.154)
lua:add_segment(4193.15, -37.154)
lua:upload_segmentstrip()


lua:create_segment(4314.22, -33.1701)
lua:add_segment(4319.59, -24.1701)
lua:add_segment(5288.35, -27.1701)
lua:upload_segmentstrip()

--Segments end


--1
switch_adv("data/scripts/srt_sewer_next_level.lua",506, 70,200,601) --script, x, y, radius, id
--2
switch_adv("data/scripts/srt_sewer_next_level.lua",2715, 79,200,602) --script, x, y, radius, id
--3
switch_adv("data/scripts/srt_sewer_next_level.lua",4269, 83,200,603) --script, x, y, radius, id
--secure kill
trigger("data/scripts/srt_game_over.lua","",30000,100,10820,-450) --script, width, height, x, y


--SEWER PIPE SETTINGS
g_sewer_aid.set_map_id(4)

--Player
--INIT PLAYER
lua:do_file("data/scripts/crt_player_trigger.lua",0)
lua:init_camera_binder(-256.0, 6095.0, -350.0, 510.0) -- left, right, bottom, up
lua:upload_player_to_layer(6)  --index of the layer
if g_sewer_aid.get_prev_map_id() == 1 then 
    lua:creature_translation("player", CPT_PLAYER, 400.0,150.0) -- set the player to it's right position
elseif g_sewer_aid.get_prev_map_id() == 2 then 
    lua:creature_translation("player", CPT_PLAYER, 2615.0,150.0) -- set the player to it's right position
elseif g_sewer_aid.get_prev_map_id() == 3 then  
    lua:creature_translation("player", CPT_PLAYER, 4369.0,150.0) -- set the player to it's right position
else
    lua:creature_translation("player", CPT_PLAYER, 400.0,150.0) -- set the player to it's right position
end
--Player end
g_level.set_level("data/scripts/lvl_sewer_4.lua")





lua:set_game_state(GS_PLAY) -- sets the game state to menu. thus you are able to use the menu commands
