-- this script is runned when the game is over
lua:set_game_state(GS_FREEZE)   --freeze the game

for b=0,lua:get_num_layers()-1,1 do
    lua:set_layer_freeze(b, true)
end
lua:set_layer_freeze(lua:get_num_layers()-1, false)
lua:set_layer_visibility(lua:get_num_layers()-1, true)

--if parameter ~= 666 then
    --stop timer
    lua:timer_stop() --stops the timer

    --The blackkened layer. --TODO: fade in
    local scale = 1000
    lua_init_texture("menu_background", "data/images/effects/black.png", FM_NEAREST, WM_REPEAT,WM_CLAMP,AM_MODULATE)
    --lua:create_sprite("background", ST_TEXTURED,"menu_background",      lua:get_camera_x(), lua:get_camera_y()) 
    lua:create_sprite("background", ST_TEXTURED,"menu_background",      0, 0) 
    lua:sprite_shape("background",ST_TEXTURED,                          scale * 16.0, scale * 16.0)
    lua:textured_sprite_tex_coords("background", ST_TEXTURED,           1.0, 1.0, 1.0, 1.0)
    lua:sprite_color("background",                                       1.0,1.0,1.0,1.0)
    --lua:convert_to_hud("background")
    g_level.upload("background",                                  lua:get_num_layers()-1) --number of layers is 5, thus the index of the upperst layer is 4

    --Print game finished text....
    --lua:create_text("game_finished","comic_sans",lua:get_camera_x(),lua:get_camera_y() + 200.0,0.2,0.75)
    lua:create_text("game_finished","comic_sans",0,0 + 250.0,0.0,0.75)
    lua:text_color("game_finished",0.9,0.1,0.1,1.0)
    lua:add_text("game_finished", "LEVEL FINISHED")
    --lua:convert_to_hud("game_finished")
    g_level.upload("game_finished",lua:get_num_layers()-1)

    --POINTS
    --Skill
    lua:create_text("game_finished","comic_sans",0,0 +200,0.0,0.75)
    lua:text_color("game_finished",1.0,0.1,0.1,1.0)
    lua:add_text("game_finished", lua:get_level_name(lua:get_timed_points()+lua:get_points()))
    g_level.upload("game_finished",lua:get_num_layers()-1)
    
    --Total points
    lua:create_text("game_finished","comic_sans",0,0 +150,0.0,0.75)
    lua:text_color("game_finished",1.0,1.0,1.0,1.0)
    lua:add_text("game_finished", "Total points: " .. tostring(lua:get_timed_points()+lua:get_points()))
    g_level.upload("game_finished",lua:get_num_layers()-1)

    --Time
    lua:create_text("game_finished","comic_sans",0,0 +100,0.0,0.75)
    lua:text_color("game_finished",1.0,1.0,1.0,1.0)
    lua:add_text("game_finished", "Time: " .. tostring(lua:get_time()) .. " s")
    g_level.upload("game_finished",lua:get_num_layers()-1)

    --Time Points
    lua:create_text("game_finished","comic_sans",0,0+50,0.0,0.75)
    lua:text_color("game_finished",1.0,1.0,1.0,1.0)
    lua:add_text("game_finished", "Time points: " .. tostring(lua:get_timed_points()))
    g_level.upload("game_finished",lua:get_num_layers()-1)

    --Bat Points
    lua:create_text("game_finished","comic_sans",0,0 -25,0.0,0.75)
    lua:text_color("game_finished",1.0,1.0,1.0,1.0)
    lua:add_text("game_finished", "Bat points: " .. tostring(lua:get_points()))
    g_level.upload("game_finished",lua:get_num_layers()-1)

    --Combo
    lua:create_text("game_finished","comic_sans",0,0 -125,0.0,0.75)
    lua:text_color("game_finished",1.0,1.0,1.0,1.0)
    lua:add_text("game_finished", "Combo: " .. tostring(lua:get_combo()) .. " of " .. tostring(lua:get_max_combo()))
    g_level.upload("game_finished",lua:get_num_layers()-1)
    
    --Buttons
    lua_init_texture("retry", "data/images/buttons/retry_btn.png", FM_NEAREST, WM_REPEAT,WM_CLAMP,AM_MODULATE)
    lua_init_texture("retry_act", "data/images/buttons/retry_btn_act.png", FM_NEAREST, WM_REPEAT,WM_CLAMP,AM_MODULATE)
    lua_init_texture("continue", "data/images/buttons/continue_btn.png", FM_NEAREST, WM_REPEAT,WM_CLAMP,AM_MODULATE)
    lua_init_texture("continue_act", "data/images/buttons/continue_btn_act.png", FM_NEAREST, WM_REPEAT,WM_CLAMP,AM_MODULATE) 
    local scale = 0.30
    local x_all = 0 --lua:get_camera_x()
    local y_all = -300 --lua:get_camera_y() -300
    lua:create_sprite("retry", ST_TEXTURED,"retry",                    -145.0 + x_all, 0.0 + y_all) 
    lua:sprite_shape("retry",ST_TEXTURED,                             scale * 512.0, scale * 256.0)
    lua:textured_sprite_tex_coords("retry", ST_TEXTURED,              0.0, 0.0, 1.0, 1.0)
    
    lua:create_sprite("retry_act", ST_TEXTURED,"retry_act",                -145.0 + x_all, 0.0 + y_all) 
    lua:sprite_shape("retry_act",ST_TEXTURED,                             scale * 512.0, scale * 256.0)
    lua:textured_sprite_tex_coords("retry_act", ST_TEXTURED,              0.0, 0.0, 1.0, 1.0)
    
    lua:create_sprite("continue", ST_TEXTURED,"continue",                145.0 + x_all, 0.0 + y_all) 
    lua:sprite_shape("continue",ST_TEXTURED,                             scale * 512.0, scale * 256.0)
    lua:textured_sprite_tex_coords("continue", ST_TEXTURED,              0.0, 0.0, 1.0, 1.0)
    
    lua:create_sprite("continue_act", ST_TEXTURED,"continue_act",            145.0 + x_all, 0.0 + y_all) 
    lua:sprite_shape("continue_act",ST_TEXTURED,                             scale * 512.0, scale * 256.0)
    lua:textured_sprite_tex_coords("continue_act", ST_TEXTURED,              0.0, 0.0, 1.0, 1.0)
    
    lua:create_button("retry_button","retry","retry_act", "","","data/scripts/srt_retry.lua") --exit
    lua:create_button("continue_button","continue","continue_act", "","","data/scripts/srt_next_level.lua") --load previous window
    lua:button_dependencies("retry_button","","","","continue_button")  --name: button name. button_up. button_down. button_left. button_right.
    lua:button_dependencies("continue_button","","","retry_button","")
    lua:set_focused_button("continue_button")  -- must be done before upload...
    g_level.upload("continue_button",lua:get_num_layers()-1) 
    g_level.upload("retry_button",lua:get_num_layers()-1) 
    
    lua:set_game_state(GS_MENU)
--elseif parameter == 666 then
    --fade_out(3)
    --timer(2.9,"data/scripts/srt_next_level.lua")
--end
    